(function() {
    'use strict';

    var yeoman = require('yeoman-generator');

    // module.exports = yeoman.generators.NamedBase.extend({
    module.exports = yeoman.generators.Base.extend({

        initializing: function () {
            this.pkg = require('../../package.json');
            // this.main = new require('../main')(this);

            // See if there is a name argument
            this.argument('className', { type: String, required: false });

            if (!this.className) {
                // Get from option
                this.className = this.options.className;
            }

            if (!this.className) {
                // Error out with required argument
                this.argument('className', { type: String, required: true });
            }
        },

        writing: {
            require: function () {

                // Copy the Gruntfile
                this.fs.copyTpl(
                    this.templatePath('Gruntfile.js'),
                    this.destinationPath('Gruntfile.js'),
                    {
                        className: this.className,
                        // TODO: Figure out how to escape these for resolving!
                        resolverOpen: '${',
                        resolverClose: '}'

                    }
                );

            }
        }

    });

})();