// Build User: <%=resolverOpen%>build.user<%=resolverClose%>
// Version: <%=resolverOpen%>build.version<%=resolverClose%>
// Build Date: <%=resolverOpen%>build.date<%=resolverClose%>

(function(root, factory) {
    'use strict';

    // Try to define a console object
    (function(){
        try {
            if (!console && ('undefined' !== typeof window)) {
                // Define the console if it does not exist
                if (!window.console) {
                    window.console = {};
                }

                // Union of Chrome, FF, IE, and Safari console methods
                var consoleFunctions = [
                    'log', 'info', 'warn', 'error', 'debug', 'trace', 'dir', 'group',
                    'groupCollapsed', 'groupEnd', 'time', 'timeEnd', 'profile', 'profileEnd',
                    'dirxml', 'assert', 'count', 'markTimeline', 'timeStamp', 'clear'
                ];
                // Define undefined methods as no-ops to prevent errors
                for (var i = 0; i < consoleFunctions.length; i++) {
                    if (!window.console[consoleFunctions[i]]) {
                        window.console[consoleFunctions[i]] = function() {};
                    }
                }
            }
        } catch(error) {
            // Not much to do if there is no console
        }

    })();

    // Determine the module system (if any)
    if (typeof define === 'function' && define.amd) {
        // AMD
        define(factory);
    } else {
        // Node
        if (typeof exports !== 'undefined') {
            module.exports = factory();
        } else {
            // None
            root.<%=className%> = factory();
        }
    }

})(this, function() {
    'use strict';

    // TODO: Put some shared private functions here

    var <%=className%> = function(/*TODO: Constructor arguments*/) {

        if (!(this instanceof <%=className%>)) {
            return new <%=className%>(/*TODO: Constructor arguments*/);
        }

        // TODO: Private instance functions here

        // TODO: Private instance variables here


        // TODO: Functions to expose here

        return {
            // TODO: Map exposed functions to the private functions
            // someFunction: _someFunction
        };

    };

    // Place the version as a member in the function
    // TODO: Uncomment if you want a version member on the class
    // <%=className%>.version = '<%=resolverOpen%>build.version<%=resolverClose%>';

    return <%= className %>;
});
